; [U^XN(C)

	; 
User:
	; XN[It
	lda	#$00
	sta	$2001

	; ~[O
	lda	#$01	; ~[O
	sta	$a000

	; oN؂ւ
	ldx	#$00
	ldy	#BANK_CHR_FRAME
	stx	$8000
	sty	$8001	; set CHR ROM to 0x0000 .. 0x07ff
	inx		; same as ldx #$01
	ldy	#BANK_CHR_MAP
	stx	$8000
	sty	$8001	; set CHR ROM to 0x0800 .. 0x0fff

	inx		; same as ldx #$02
	ldy	#BANK_CHR_PLAYER
	stx	$8000
	sty	$8001	; set CHR ROM to 0x1000 .. 0x13ff
	inx		; same as ldx #$03
	ldy	#BANK_CHR_SHOT
	stx	$8000
	sty	$8001	; set CHR ROM to 0x1400 .. 0x17ff
	inx		; same as ldx #$04
	ldy	#BANK_CHR_BOSS
	stx	$8000
	sty	$8001	; set CHR ROM to 0x1800 .. 0x1bff
	inx		; same as ldx #$05
	ldy	#BANK_CHR_BOSS
	stx	$8000
	sty	$8001	; set CHR ROM to 0x1c00 .. 0x1fff

	lda	#BANK_PRG_SMC
	jsr	SetPrgBankA
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; PRG-RAMݒ
	lda	#$80
	sta	$a001

	lda	#LOW(CopyMemoryParam_SMC)
	ldx	#HIGH(CopyMemoryParam_SMC)
	jsr	CopyMemory

	jsr	SMCL(ClearExtWorkMemory)

	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA

	; pbg
	lda	#PS_BG_SELECT
	jsr	Pal_SetBGPalette
	lda	#PS_SP_GAME
	jsr	Pal_SetSPPalette
	lda	#$40
	jsr	Vcmd_SetPalette

	; XN[ݒ
	lda	#$00
	sta	<SCROLL_X
	lda	#$e8
	sta	<SCROLL_Y

	; @/G~[^
	lda	#LOW(User_Nmi_MC)
	sta	NMI_FNC
	lda	#HIGH(User_Nmi_MC)
	sta	NMI_FNC+1

	lda	#LOW(User_Irq_MC)
	sta	IRQ_FNC
	lda	#HIGH(User_Irq_MC)
	sta	IRQ_FNC+1
	lda	#1
	sta	<IRQ_LINE

	jsr	Yeild		; t[܂őҋ@

	lda	#$2f
	ldy	#$1d
	ldx	#3
.1:
	sta	$2006
	sty	$2006
	sty	$2007
	eor	#$10
	dex
	bpl	.1
	lda	$00
	sta	$c000
	sta	$e000
	sta	<IRQ_LINE

	; NMI^XNݒ
	lda	#LOW(User_Nmi)
	sta	NMI_FNC
	lda	#HIGH(User_Nmi)
	sta	NMI_FNC+1

	; IRQ^XNݒ
	lda	SYS_REAL
	beq	.2
	ldx	#LOW(User_Irq_Real)
	ldy	#HIGH(User_Irq_Real)
	bne	.3	; same as jmp
.2:
	ldx	#LOW(User_Irq_Emu)
	ldy	#HIGH(User_Irq_Emu)
.3:
	stx	IRQ_FNC
	sty	IRQ_FNC+1
	lda	#7
	sta	<IRQ_LINE

	; jmpߐݒ
	lda	#$6c
	sta	<USR_FNC-1
	sta	<EN_FNC-1
	sta	<SH_FNC-1
	lda	#HIGH(FN_EN_UPD)
	sta	<USR_FNC+1
	lda	#HIGH(EN_CB)
	sta	<EN_FNC+1
	lda	#HIGH(SH_CB)
	sta	<SH_FNC+1

	; TEhݒ
	; SE͓oNɊi[Ă̂ŏɂP񂾂ݒ
	lda	#($80+BANK_PRG_DATA)
	jsr	Fssq_SetBankSE
	jsr	Sound_InitPCM

	; ϐ
	ldx	#$00
	stx	<JOY_PREV	; Pt[O̓͏
	stx	<JOY_ASSIGN
	jsr	Joy_AssignButton

	; XvCg
	jsr	Spr_Init

	jsr	Yeild_SetEntry	; t[͂

	; ʏ
	lda	#LOW(Vcmd_Clear)
	ldx	#HIGH(Vcmd_Clear)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; XN[I
	lda	#$8a
	sta	<PPU_REG1
	sta	$2000
	lda	#$1e
	sta	$2001

	jsr	Yeild		; t[܂őҋ@

Title_Init1:
	; BGMt
	ldy	#1
	sty	MUSIC_POS
	jsr	Bgm_Control

Title_Init2:
	; [N揉
	lda	#0
	sta	<ST_CNT
	sta	<ST_CNT+1
	sta	IS_DEMO
	jsr	Joy_Title_Init

	; BGpoN؂ւ
	lda	#BANK_CHR_TITLE
	ldx	#$00
	jsr	Util_SetSyncBank
	lda	#BANK_CHR_TITLE+2
	sta	<BGS_BANK	; NMỈŐ؂ւ

	; SPpoN؂ւ
	lda	#BANK_CHR_TITLE2
	ldx	#$02
	jsr	Util_SetSyncBank

	; pbgݒ
	lda	#PS_BG_TITLE
	jsr	Pal_SetBGPalette
	lda	<CUR_POS
	ora	#PS_SP_TITLE
	jsr	Pal_SetSPPalette

	; ʃ[h
	lda	#$40
	sta	<IRQ_MODE

	; XN[ݒ
	lda	#$00
	sta	<SCROLL_X
	jsr	Yeild_SetEntry

	; ʘg`
	lda	#LOW(Vcmd_Title)
	ldx	#HIGH(Vcmd_Title)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	ldy	<CUR_POS
	lda	Vcmd_TitleOn_lo,y
	ldx	Vcmd_TitleOn_hi,y
	jsr	Vcmd_SequenceData

	; XvCg`
	jsr	Spr_Init

	lda	#1
	sta	<SPR_INX

	lda	#128
	sta	<FNC_ARG
	lda	#168
	sta	<FNC_ARG+1
	ldx	#LOW(Spr_Data_Title_Reimu)
	ldy	#HIGH(Spr_Data_Title_Reimu)
	jsr	Spr_Put

;	lda	#176
;	sta	<FNC_ARG
;	lda	#40
;	sta	<FNC_ARG+1
;	ldx	#LOW(Spr_Data_Title_X68)
;	ldy	#HIGH(Spr_Data_Title_X68)
;	jsr	Spr_Put

	; tF[hC
	jsr	FadeIn

Title_Main:
	jsr	Joy_Title

	; \XV
	ldy	<CUR_POS
	cpy	<CUR_PREV
	beq	.1

	lda	Vcmd_TitleOn_lo,y
	ldx	Vcmd_TitleOn_hi,y
	jsr	Vcmd_SequenceData

	lda	#LOW(Se_Select_PlayData)
	ldx	#HIGH(Se_Select_PlayData)
	jsr	Fssq_PlaySE
.1:

	; is
	lda	<CUR_RESULT
	bit	<CUR_RESULT
	bmi	.4
	and	#$3f
	beq	.8	; Start
	cmp	#1
	beq	.3
	; Option or HowToPlay or Cancel
	lda	#LOW(Se_Cancel_PlayData)
	ldx	#HIGH(Se_Cancel_PlayData)
	jsr	Fssq_PlaySE
	jmp	.6
.3:
	.if	0
	; SEeXg
	lda	<JOYPAD
	and	#JOY_A
	beq	.90
	ldy	#0
	jsr	Bgm_Control
.90:
	lda	#LOW(Se_PlayData)
	ldx	#HIGH(Se_PlayData)
	jsr	Fssq_PlaySE

	.else
	.if	0
	; BGMeXg
	ldy	#16
	jsr	Bgm_Control

	.else

	; BGMZNg
;	ldy	MUSIC_POS
;	iny
;	cpy	#11
;	bcc	.90
;	ldy	#0
;.90:
;	sty	MUSIC_POS
;	jsr	Bgm_Control

	lda	<JOY_ASSIGN
	bvc	.90
	eor	#$01
	sta	<JOY_ASSIGN
.90:
	tax
	jsr	Joy_AssignButton
	jsr	Proc_MusicRoom
	jmp	Title_Init1

	.endif
	.endif

	jmp	.6
.4:
	lda	<CUR_POS
	bne	.6
	inc	<ST_CNT
	bne	.5
	inc	<ST_CNT+1
.5:
	lda	<ST_CNT
	cmp	#LOW(4620)
;	cmp	#LOW(180)
	bne	.7
	lda	<ST_CNT+1
	cmp	#HIGH(4620)
;	cmp	#HIGH(180)
	bne	.7

	; f
	inc	IS_DEMO

	jsr	Rand
	sta	<PL_T
	lsr	a
	adc	<PL_T
	rol	a
	rol	a
	rol	a
	and	#$07
	sta	<PL_T

	jsr	Rand
	and	#$01
	sec
	adc	<ST_NUM
	cmp	#5
	bcc	.demo1
	sbc	#5
.demo1:
	sta	<ST_NUM

	lda	#$00
	sta	<DEMO_PAD
	lda	#$ff
	sta	<DEMO_EINX

	; XN[ݒ
	lda	#$04
	sta	<SCROLL_X

	jmp	Select_End
.6:
	lda	#$00
	sta	<ST_CNT
	sta	<ST_CNT+1
.7:
	lda	#$ff
	sta	<CUR_RESULT
	jsr	Yeild_ReEntry	; t[܂őҋ@

.8:
	bvc	.9
	lda	<JOY_ASSIGN
	eor	#$01
	sta	<JOY_ASSIGN
.9:
	jsr	Yeild	; t[܂őҋ@

	lda	#LOW(Se_Ok_PlayData)
	ldx	#HIGH(Se_Ok_PlayData)
	jsr	Fssq_PlaySE

	; XvCg
	jsr	Spr_Init

	; tF[hAEg
	jsr	FadeOut

Select_Init:
	lda	#BANK_PRG_DRAW2
	jsr	SetPrgBankB

	; [N揉
	jsr	Joy_Select_Init

	; BGpoN؂ւ
	lda	#BANK_CHR_SELECT
	ldx	#$00
	jsr	Util_SetSyncBank
	lda	#BANK_CHR_SELECT+2
	sta	<BGS_BANK	; NMỈŐ؂ւ

	; SPpoN؂ւ
	lda	#BANK_CHR_NAME
	ldx	#$03
	jsr	Util_SetSyncBank

	lda	<CUR_POS
	lsr	a
	tax
	lda	Spr_Figure_Player_bank,x
	ldx	#$02
	jsr	Util_SetSyncBank

	; pbgݒ
	lda	#PS_BG_SELECT
	jsr	Pal_SetBGPalette
	lda	<CUR_POS
	ora	#PS_SP_SELECT
	jsr	Pal_SetSPPalette

	; ʃ[h
	lda	#$40
	sta	<IRQ_MODE

	; XN[ݒ
	lda	#$04
	sta	<SCROLL_X

	jsr	Yeild_SetEntry

	; ʘg`
	lda	#LOW(Vcmd_Select)
	ldx	#HIGH(Vcmd_Select)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	ldy	<CUR_POS
	lda	Vcmd_SelectOn_lo,y
	ldx	Vcmd_SelectOn_hi,y
	jsr	Vcmd_SequenceData

	ldy	<JOY_ASSIGN
	lda	Vcmd_SelectAssign_lo,y
	ldx	Vcmd_SelectAssign_hi,y
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hC
	jsr	FadeIn

Select_Main:
	lda	#16
	sta	<USR_CNT
	jsr	Yeild_SetEntry

	jsr	Joy_Select

	lda	#BANK_PRG_DRAW2
	jsr	SetPrgBankB

	; \XV
	jsr	Proc_SelectDisp

	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; is
	lda	<CUR_RESULT
	bmi	.7
	cmp	#$40	; Cancel
	bcc	.6

	lda	<CUR_POS
	sta	<PL_T

	lda	#LOW(Se_Cancel_PlayData)
	ldx	#HIGH(Se_Cancel_PlayData)
	jsr	Fssq_PlaySE

	; tF[hAEg
	jsr	FadeOut

	jmp	Title_Init2

.6:
	sta	<PL_T
	lda	#0
.7:
	jsr	Yeild_Eq	; t[܂őҋ@

	lda	#LOW(Se_Ok_PlayData)
	ldx	#HIGH(Se_Ok_PlayData)
	jsr	Fssq_PlaySE

Select_End:
	; tF[hAEg
	jsr	FadeOut

	; XvCg
	jsr	Spr_Init

	; BGM~
	ldy	#0
	jsr	Bgm_Control

Game_Init:	; Q[{̂ɈڍsP񂾂̏
	; ʃ[h
	lda	#$00
	sta	<IRQ_MODE

;	lda	#$00
	sta	<DSP_FLAG
	ldx	IS_DEMO
	bne	.1
	.if	OPT_DEMO
	lda	#OPT_DEMO_STAGE
	.endif
	sta	<ST_NUM
.1:

	; CxgV[PT
	jsr	EventSeq_Init

	; g[NV[PT
	jsr	TalkSeq_Init

	; vC[p[`̓]
	lda	<PL_T
	lsr	a
	ora	#BANK_PRG_PLAYER
	jsr	SetPrgBankA

	ldy	<PL_T
	lda	CopyMemoryParam_PLC1_L,y
	ldx	CopyMemoryParam_PLC1_H,y
	jsr	CopyMemory

	ldy	<PL_T
	lda	CopyMemoryParam_PLC2_L,y
	ldx	CopyMemoryParam_PLC2_H,y
	jsr	CopyMemory

	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA

	; vC[
	lda	#0
	sta	<PL_SCORE
	sta	<PL_SCORE+1
	sta	<PL_SCORE+2
	ldx	#(PL_POINT_NEXT+2-PL_STOCK-1)
.2:
	sta	<PL_STOCK,x
	dex
	bpl	.2

	lda	#0
	sta	CONT_NUM
	lda	#OPT_PL_STOCK
	sta	<PL_STOCK
	lda	PLC_BOMB
	sta	<PL_BOMB
	.if	OPT_DEMO
	.if	0
	lda	#64
	.else
	lda	#120
	.endif
	sta	<PL_POWER
	lda	<DSP_FLAG
	ora	#DSF_POWER
	sta	<DSP_FLAG
	.endif

	ldx	#3
.3:
	lda	PLC_SPEED_PRIM,x
	sta	PLC_SPEED,x
	dex
	bpl	.3

	lda	ExtendTable_L
	sta	<PL_POINT_NEXT
	lda	ExtendTable_H
	sta	<PL_POINT_NEXT+1
	lda	#1
	sta	<EXTEND_INX
	lda	#LOW(20000)
	sta	<PL_CHERRY_MAX
	lda	#HIGH(20000)
	sta	<PL_CHERRY_MAX+1

	; BGpoN؂ւ
	lda	#BANK_CHR_FRAME
	ldx	#$00
	jsr	Util_SetSyncBank

	; pbg
	lda	#PS_BG_FRAME
	jsr	Pal_SetBGPalette

	jsr	Yeild_SetEntry

	; SMC
	lda	#ITEM_BONUS
	sta	SMCL(Shot_ResolveBonusOrCherry+1)

	; ʘg`
	lda	#LOW(Vcmd_Frame)
	ldx	#HIGH(Vcmd_Frame)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; `
	jsr	Vcmd_ReflectHiScore	; nCXRA
.reflect1:
	jsr	Vcmd_ReflectStock	; c@
	lda	<PL_STOCK
	cmp	<PL_STOCK+1
	bne	.reflect1
.reflect2:
	jsr	Vcmd_ReflectBomb	; {
	lda	<PL_BOMB
	cmp	<PL_BOMB+1
	bne	.reflect2
	jsr	Vcmd_ReflectPointNext	; |Cg(GNXeh)
	jsr	Vcmd_ReflectCherryMax	; _ől

	jsr	Yeild		; t[܂őҋ@

	; tF[hC
	jsr	FadeIn

Game_Setup:	; Xe[WJnƂ̏
	; : ʂ\܂܂ŏ̂
	;       ꂪoȂ悤ɂ邱

	; Xe[WCfbNX̃Rs[
	lda	<ST_NUM
;	ora	#BANK_PRG_INDEX
	jsr	SetPrgBankA
	jsr	SMCL(CopyStageIndex)

	; Frame^XNݒ
	lda	#LOW(User_Frame_StageStart)
	sta	FRM_FNC
	lda	#HIGH(User_Frame_StageStart)
	sta	FRM_FNC+1

	lda	#$00
	sta	<BGS_UPD_CNT

	; ʃ[h
;	lda	#$00
	sta	<IRQ_MODE

	; oN؂ւ
	lda	SEQ_BANK_EVENT
	jsr	SetPrgBankA
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	lda	<PL_T
	and	#$06
	lsr	a
;	clc
	adc	#BANK_CHR_PLAYER
	ldx	#$02
	jsr	Util_SetSyncBank

	inx		; same as ldx #$03
	lda	#BANK_CHR_SHOT
	jsr	Util_SetSyncBank

	; vC[
	lda	#0
	sta	<PL_S
	sta	<PL_OPT
	sta	<PL_REQ
	sta	<PL_INV_CNT
	sta	<PL_BORDER_TIME
	lda	#64
	sta	<PL_X
	lda	#$1f
	sta	<PL_CNT
	lda	<PL_CHERRY_MAX
	sta	PL_CHERRY_BASE
	lda	<PL_CHERRY_MAX+1
	sta	PL_CHERRY_BASE+1
	lda	<PL_POINT
	sta	PL_POINT_BASE
	lda	<PL_POINT+1
	sta	PL_POINT_BASE+1
	lda	<PL_GRAZE
	sta	PL_GRAZE_BASE
	lda	<PL_GRAZE+1
	sta	PL_GRAZE_BASE+1

	; pbgݒ
	lda	#PS_BG_FRAME
	jsr	Pal_SetBGPalette
	lda	#PS_SP_GAME
	jsr	Pal_SetSPPalette
	lda	#$00
	jsr	Vcmd_SetPalette

	; BGV[PTݒ
	jsr	BGSeq_Init
	ldx	#0
	lda	SEQ_TBL_LAND
	ldy	SEQ_TBL_LAND+1
	jsr	BGSeq_SetSeq
	jsr	BGSeq_ClearPalette

	; CxgV[PTݒ
	ldx	SEQ_TBL
	ldy	SEQ_TBL+1
	jsr	EventSeq_SetSeq

	; XvCg
	jsr	Spr_Init

	; G
	jsr	Enemy_Init

	; eǗ
	jsr	Shot_Init

	; ̑[N揉
	lda	#$00
	sta	<USR_CNT
	sta	<TRI_CNT
	sta	<SND_SE
	sta	<SND_SE+1
	sta	<EN_TIME

	jsr	Yeild_SetEntry

Game_Start:	; Xe[WJn̉o

	lda	#BANK_PRG_DRAW
	jsr	SetPrgBankA
	lda	#BANK_PRG_DRAW2
	jsr	SetPrgBankB

	lda	#1
	sta	<SPR_INX

	ldx	<PL_CNT
	bmi	.1
	lda	Player_EnterPosY,x
	sta	<PL_Y
	dec	<PL_CNT
.1:
	jsr	PLC_PL_DRAW

	lda	<SPR_INX
	beq	.draw2
	and	#$fc
	tax
.draw1:
	lda	#240
	sta	SPR_DATA,x
	lda	Int+4,x
	tax
	bne	.draw1
.draw2:

	lda	#1
	sta	<SPR_UPD

	lda	SEQ_BANK_EVENT
	jsr	SetPrgBankA
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	inc	<USR_CNT
	lda	<TRI_CNT
	cmp	#2
	adc	#1
	and	#$03
	sta	<TRI_CNT

	; }bv`抮҂
	lda	<BGS_UPD_CNT
	cmp	#$ff
	jsr	Yeild_Eq	; t[܂őҋ@

	jsr	Yeild	; t[܂őҋ@

	; Frame^XNݒ
	lda	#LOW(User_Frame_Game)
	sta	FRM_FNC
	lda	#HIGH(User_Frame_Game)
	sta	FRM_FNC+1

	lda	#$00
	sta	<ST_CNT
	sta	<ST_CNT+1
	sta	<BGS_UPD_CNT
	sta	<PL_CNT

Game_Start2:
	jsr	Yeild_SetEntry

Game_Main:
	lda	<PL_REQ
	and	#$10
	beq	.evupd

	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA

	jsr	Joy_Pause
	lda	<JOYPAD
	sta	<JOY_PREV
	jmp	.draw
.evupd:
	; CxgV[PTXV
	jsr	EventSeq_Update
	sta	<USR_WORK

	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA

	; 
	.if	OPT_DISABLE_FALL
	.else	; OPT_DISABLE_FALL

	lda	<PL_S
	and	#$a0
	bne	.joy2

	.endif	; OPT_DISABLE_FALL

	lda	IS_DEMO
	bne	.joy1

	jsr	Joy_Player
	jmp	.joy2
.joy1:
	jsr	Joy_Demo
.joy2:
	lda	<JOYPAD
	sta	<JOY_PREV

	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; XV
	lda	<PL_S
	and	#$a0
	bne	.upd1
	jsr	PLC_PL_UPDATE
	jmp	.upd2
.upd1:
	jsr	Player_UpdateRetire
.upd2:
	lda	<PL_INV_CNT
	beq	.upd3
	dec	<PL_INV_CNT
.upd3:
	lda	SEQ_BANK_EVENT
	jsr	SetPrgBankA

	jsr	Enemy_Update
	lda	<PL_REQ
	bmi	.upd4
	jsr	Shot_Update
.upd4:
	ldx	#8
	lda	<QUAKE_CNT
	beq	.upd5
	dec	<QUAKE_CNT
	bne	.upd6
.upd5:
	lda	<PL_REQ
	and	#$20
	beq	.upd7
.upd6:
	jsr	Rand
	and	#$07
	tax
.upd7:
	lda	QuakePos,x
	sta	<SCROLL_X
	lda	QuakePos+9,x
	sta	<IRQ_LINE

	lda	<USR_CNT
	and	#$07
	bne	.upd10
	lda	<PL_BORDER_TIME
	bmi	.upd8
	beq	.upd10
	dec	<PL_BORDER_TIME
	bne	.upd10
	jsr	Player_ConvergeBorder
	jmp	.upd9	; same as jmp
.upd8:
	dec	<PL_BORDER_TIME
	cmp	#$fd
	bcs	.upd10
	lda	#$00
	sta	<PL_BORDER_TIME
.upd9:
	lda	#$02
	ora	<BGC_PAL
	sta	<BGC_PAL
	lda	<BGC_REF+1
	ora	#(BGF_PALETTE)
	sta	<BGC_REF+1
.upd10:

	; \
.draw:
	lda	#1
	sta	<SPR_INX

	lda	#BANK_PRG_DRAW
	jsr	SetPrgBankA
	lda	#BANK_PRG_DRAW2
	jsr	SetPrgBankB

	lda	<PL_S
	bmi	.draw1
	jsr	PLC_PL_DRAW
	jmp	.draw2
.draw1:
	jsr	Player_DrawRetire
.draw2:
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	jsr	Enemy_Draw

	lda	#BANK_PRG_DRAW3
	jsr	SetPrgBankA

	jsr	SMCL(Shot_Draw)
	jsr	BGSeq_DrawLayer

	lda	SEQ_BANK_EVENT
	jsr	SetPrgBankA

	lda	<SPR_INX
	beq	.draw4
	and	#$fc
	tax
.draw3:
	lda	#240
	sta	SPR_DATA,x
	lda	Int+4,x
	tax
	bne	.draw3
.draw4:

	lda	#1
	sta	<SPR_UPD

	; SEt
	jsr	Bgm_PlaySE

	; JE^XV
	inc	<USR_CNT
	lda	<TRI_CNT
	cmp	#2
	adc	#1
	and	#$03
	sta	<TRI_CNT

	; ԑJ
	lda	<PL_STOCK
	bpl	.next1
	lda	<PL_S
	bmi	.next1
	jmp	Game_Cont
.next1:
	lda	<USR_WORK
	bmi	Game_End
	bne	.next3
	lda	<IRQ_X
	and	#$0f
	beq	.next2
	lda	#BANK_PRG_DATA
	cmp	$bfff
	bne	.next2
	jsr	Proc_LoadControl
.next2:
	jsr	Yeild_ReEntry
.next3:
	jmp	Talk_Start

Game_End:	; Xe[WỈo
	; oN؂ւ
	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; XvCg
	jsr	Spr_Init

	; vC[
	lda	#0
	sta	<PL_BORDER_TIME

	; pbgݒ
	lda	#PS_BG_FRAME
	jsr	Pal_SetBGPalette
	lda	#$00
	jsr	Vcmd_SetPalette

	; Frame^XNݒ
	lda	#LOW(User_Frame_StageEnd)
	sta	FRM_FNC
	lda	#HIGH(User_Frame_StageEnd)
	sta	FRM_FNC+1

	lda	#7
	sta	<IRQ_LINE

	lda	#$00
	sta	<BGS_UPD_CNT

	jsr	Yeild	; t[܂őҋ@

	; XRA{[h`抮҂
	lda	<BGS_UPD_CNT
	cmp	#$ff
	jsr	Yeild_Eq	; t[܂őҋ@

	; ʂFront/BackԂɖ߂
	lda	#$00
	sta	<IRQ_MODE

	; f
	lda	IS_DEMO
	beq	.1
	jmp	_Game_Gameover2
.1:

	; LoN؂ւ
	lda	#BANK_CHR_FRAME2
	sta	<BGS_BANK

	jsr	Proc_Scoreboard

	jsr	Yeild_SetEntry

	; ŏIʔ
	lda	<ST_NUM
	cmp	#5
	bcs	.3

	; ʏ
	lda	#LOW(Vcmd_BoardClear)
	ldx	#HIGH(Vcmd_BoardClear)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	inc	<ST_NUM		; Xe[WɈڍs
	jmp	Game_Setup

.3:
	; bZ[W\
	lda	#LOW(Vcmd_Apology)
	ldx	#HIGH(Vcmd_Apology)
	jsr	Vcmd_SequenceData

	jmp	_Game_Gameover1

Game_Cont:
	; Frame^XNݒ
	lda	#$00
	sta	FRM_FNC
	sta	FRM_FNC+1

	lda	#7
	sta	<IRQ_LINE

	jsr	Yeild	; t[܂őҋ@

	; oN؂ւ
	lda	$9fff
	sta	<USR_WORK+1
	lda	$bfff
	sta	<USR_WORK+2
	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA
	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	lda	#BANK_CHR_CONT
	ldx	#$03
	jsr	Util_SetSyncBank

	; pbgݒ
	lda	#PS_SP_CONTINUE
	jsr	Pal_SetSPPalette
	lda	#$00
	jsr	Vcmd_SetPalette

	; vC[
	lda	#0
	sta	<PL_BORDER_TIME

	; tꎞ~
	jsr	Fssq_PauseBGM

	inc	CONT_NUM
	lda	CONT_NUM
	cmp	#OPT_CONT_NUM
	bcc	.1
	jmp	Game_Gameover
.1:
	jsr	Joy_Continue_Init

.2:
	; XvCg
	jsr	Spr_Init

	lda	#1
	sta	<SPR_INX

	; XvCgݒ
	lda	#64
	sta	<FNC_ARG
	sta	<FNC_ARG+1
	ldx	#LOW(Spr_Data_Continue)
	ldy	#HIGH(Spr_Data_Continue)
	jsr	Spr_Put

	lda	<CUR_POS
	bne	.3
	ldx	#LOW(Spr_Data_Continue_Yes)
	ldy	#HIGH(Spr_Data_Continue_Yes)
	jmp	.4
.3:
	ldx	#LOW(Spr_Data_Continue_No)
	ldy	#HIGH(Spr_Data_Continue_No)
.4:
	lda	#64
	sta	<FNC_ARG
	lda	#84
	sta	<FNC_ARG+1
	jsr	Spr_Put

	jsr	Yeild	; t[܂őҋ@

	; ҂
	jsr	Joy_Continue

	lda	<CUR_POS
	cmp	<CUR_PREV
	beq	.5

	lda	#LOW(Se_Select_PlayData)
	ldx	#HIGH(Se_Select_PlayData)
	jsr	Fssq_PlaySE
.5:
	; is
	lda	<CUR_RESULT
	bmi	.2
	beq	.6
	jmp	Game_Gameover
.6:
	; vC[
	lda	#OPT_PL_STOCK
	sta	<PL_STOCK
	lda	PLC_BOMB
	sta	<PL_BOMB

	; pbg
	lda	#PS_SP_GAME
	jsr	Pal_SetSPPalette
	lda	#$00
	jsr	Vcmd_SetPalette

	; oN
	lda	<USR_WORK+1
	jsr	SetPrgBankA
	lda	<USR_WORK+2
	jsr	SetPrgBankB

	lda	#BANK_CHR_SHOT
	ldx	#$03
	jsr	Util_SetSyncBank

	; tĊJ
	jsr	Fssq_ResumeBGM

	; Frame^XNݒ
	lda	#LOW(User_Frame_Game)
	sta	FRM_FNC
	lda	#HIGH(User_Frame_Game)
	sta	FRM_FNC+1

	jmp	Game_Start2

Game_Gameover:
	; t~
	ldy	#0
	jsr	Bgm_Control

	; XvCg
	jsr	Spr_Init

	lda	#1
	sta	<SPR_INX

	; XvCgݒ
	lda	#64
	sta	<FNC_ARG
	sta	<FNC_ARG+1
	ldx	#LOW(Spr_Data_Gameover)
	ldy	#HIGH(Spr_Data_Gameover)
	jsr	Spr_Put

	jsr	Yeild	; t[܂őҋ@

_Game_Gameover1:
	; ҂
	lda	#0
	sta	<JOY_CNT1

	jsr	Yeild	; t[܂őҋ@

	; ҂
	jsr	Joy_Waiting
	bvs	.1
	jsr	Yeild_ReEntry
.1:
	jsr	Yeild_SetEntry

_Game_Gameover2:
	; XvCg
	jsr	Spr_Init

	; tF[hAEg
	jsr	FadeOut

	; ʏ
	lda	#LOW(Vcmd_Clear)
	ldx	#HIGH(Vcmd_Clear)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	jmp	Title_Init1

Talk_Start:
	asl	a
	asl	a
	tax

	lda	#4
	sta	<SCROLL_X
	lda	#7
	sta	<IRQ_LINE

	lda	SEQ_TBL_TALK+2-4,x
	ldy	SEQ_TBL_TALK+3-4,x
	jsr	TalkSeq_SetSeq

	lda	SEQ_TBL_TALK+1-4,x
	sta	<IRQ_BANK+1
	lda	SEQ_TBL_TALK+0-4,x
	sta	<TKS_BANK

	jsr	Yeild_SetEntry

	; bʂӂ
	lda	<VCMD_SIZE
	cmp	#(160-20+1)
	bcc	.1
	jsr	Yeild_ReEntry
.1:
	lda	#LOW(Vcmd_Talk1)
	ldx	#HIGH(Vcmd_Talk1)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	jsr	Yeild_SetEntry

	; GCtQ[WGʒup
	lda	<VCMD_SIZE
	cmp	#(160-20+1)
	bcc	.2
	jsr	Yeild_ReEntry
.2:
	lda	#LOW(Vcmd_Talk2)
	ldx	#HIGH(Vcmd_Talk2)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; XvCgoNԍޔ
	lda	SYN_BANK+3
	sta	<TKS_SAVE_BANK
	lda	SYN_BANK+6
	sta	<TKS_SAVE_BANK+1

	; bʕ\
	lda	<IRQ_MODE
	and	#$cf
	ora	#SSF_MODE_TALK
	sta	<IRQ_MODE

	lda	#0
	sta	<TKS_POS
	sta	<TKS_DISP
	sta	<TKS_CTRL

	jsr	Yeild_SetEntry
Talk_Main:
	lda	$9fff	; oNԍۑ
	sta	<USR_WORK+1
	lda	<TKS_BANK
	jsr	SetPrgBankA

	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; g[NV[PTXV
	jsr	TalkSeq_Update
	sta	<USR_WORK

	lda	#BANK_PRG_MENU
	jsr	SetPrgBankA

	; 
	lda	<TKS_CTRL
	bpl	.joy3
	ldx	IS_DEMO
	beq	.joy1
	inc	<JOY_CNT1
	inc	<JOY_CNT1
	bit	<JOY_CNT1
	bpl	.joy2	; same as jmp
.joy1:
	jsr	Joy_Waiting
.joy2:
	bvc	.joy3
	lda	#$c0
	sta	<TKS_CTRL
.joy3:

	lda	<USR_WORK+1
	jsr	SetPrgBankA
	lda	#BANK_PRG_DRAW2
	jsr	SetPrgBankB

	; \
	jsr	Proc_TalkDisp

	lda	#BANK_PRG_DATA
	jsr	SetPrgBankB

	; SEt
	jsr	Bgm_PlaySE

	; JE^XV
	inc	<USR_CNT
	lda	<TRI_CNT
	cmp	#2
	adc	#1
	and	#$03
	sta	<TRI_CNT

	; ԑJ
	lda	<TKS_CTRL
	lsr	a
	bcs	Talk_Clear

	lda	<USR_WORK
	bne	Talk_End
	jsr	Yeild_ReEntry

Talk_Clear:
	jsr	Yeild_SetEntry

	; bʂӂ
	lda	<VCMD_SIZE
	cmp	#(160-20+1)
	bcc	.1
	jsr	Yeild_ReEntry
.1:
	lda	#LOW(Vcmd_Talk1)
	ldx	#HIGH(Vcmd_Talk1)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	lda	#$00
	sta	<TKS_CTRL
	jmp	Talk_Main-3

Talk_End:
	; XvCg
	jsr	Spr_Init

	; XvCgoNԍ
	lda	<TKS_SAVE_BANK
	ldx	#2
	jsr	Util_SetSyncBank
	lda	<TKS_SAVE_BANK+1
	ldx	#5
	jsr	Util_SetSyncBank

	; ʏʕ\
	lda	<IRQ_MODE
	and	#$cf
	ora	#SSF_MODE_NORMAL
	sta	<IRQ_MODE

	jsr	Yeild_SetEntry

	; GCtQ[WGʒu
	lda	<VCMD_SIZE
	cmp	#(160-20+1)
	bcc	.1
	jsr	Yeild_ReEntry
.1:
	lda	#LOW(Vcmd_Talk3)
	ldx	#HIGH(Vcmd_Talk3)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	lda	#$00
	sta	<EN_LIFE_INX+1

	jsr	TalkSeq_Init

	jmp	Game_Start2

	; tF[hC
FadeIn:
	lda	#$07
	sta	<USR_CNT
	jsr	Yeild_SetEntry

	lda	<USR_CNT
	asl	a
	asl	a
	asl	a
	and	#$f0
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	bne	.1
	jmp	Yeild	; t[܂őҋ@
.1:
	jmp	_ReEntry

	; tF[hAEg
FadeOut:
	lda	#$01
	sta	<USR_CNT
	jsr	Yeild_SetEntry

	lda	<USR_CNT
	asl	a
	asl	a
	asl	a
	and	#$f0
	jsr	Vcmd_SetPalette

	inc	<USR_CNT
	lda	<USR_CNT
	cmp	#$09
	bne	.1
	jmp	Yeild	; t[܂őҋ@
.1:
	jmp	_ReEntry

	; @pNmi
User_Nmi_MC:
	pla
	pla
	ldy	<SUS_NMI_Y
	ldx	<SUS_NMI_X
	pla
	rti

	; @pIrq
User_Irq_MC:
	lda	#$00
	sta	$c000
	sta	$e000
	sta	<IRQ_LINE
	inc	SYS_REAL
	rts

User_Nmi:
	; VTAM]160oCg̏ꍇ
	; VXeł̃XN[ʒuݒ
	; (VRAMAhX̍Đݒ)ԂɍȂ̂
	; Őɐݒ肷

	; XN[ʒuݒ
	lda	<SCROLL_X
	sta	$2005
	lda	<SCROLL_Y
	sta	$2005

	; Base Nametable Addr̐ݒ
	lda	<PPU_REG1
	and	#$7f
	sta	$2000

	lda	<IRQ_MODE
	lsr	a
	lsr	a
	lsr	a
	tax
	lda	Irq_ModeTableL,x
	sta	<IRQ_TBL
	lda	Irq_ModeTableH,x
	sta	<IRQ_TBL+1

	ldx	#$01
	lda	<IRQ_MODE
	and	#$07
	asl	a
	adc	<BGS_BANK	; BGS_BANK+(IRQ_MODE&7)*2
	stx	$8000
	sta	$8001
	sta	<IRQ_BANK

	ldy	#0
	lda	[IRQ_TBL],y
	sta	<IRQ_X
	iny
	lda	[IRQ_TBL],y
	sta	<IRQ_Y
	iny
	sty	<IRQ_CNT

	lda	SYN_BANK
	beq	.3
	ldx	#6
	asl	a
.1:
	asl	a
	beq	.2
	dex
	cmp	#$80
	bcc	.1
	ldy	SYN_BANK+1,x
	stx	$8000
	sty	$8001
	bcs	.1
.2:
	sta	SYN_BANK
.3:

	lda	$2002	; clear address latch

	; PCMf[^̐ݒ
	lda	#$20
	cmp	<PCM_CNT
	bcc	.4
	sta	<PCM_CNT
.4:

	rts

Player_EnterPosY:
	.db	164,165,165,166,166,167,167,168
	.db	169,170,172,173,175,176,178,180
	.db	182,184,187,199,192,194,197,200
	.db	203,206,210,213,217,220,224,228

.align:
	.org	(HIGH(.align)+1)*256
	; clk/line : 341ppu : 113.667 cpu
	; total 7+24  +12+14+18+35 = 110clk for emu
	; total 7+24+5+12+14+18+35 = 115clk for real machine
User_Irq_Real:
	lda	<IRQ_X		; 3
	nop			; 2
User_Irq_Emu:
	nop			; 2
	lda	<IRQ_X		; 3
	cmp	#$80		; 2
	bit	<IRQ_X		; 3
	and	#$0f		; 2

	sta	$c000		; 4
	sta	$e000		; 4
	beq	.2		; 2/3

	; irq enable
	sta	$e001		; 4
.1:
	; set chr-bank
	ldx	#$01		; 2
	bcc	.5		; 2/3
	lda	<IRQ_BANK+1	; 3
	bcs	.6		; 3 same as jmp
.2:
	; irq disable
	beq	.1		; 3 same as jmp
.4:
	pla			; 4
	pha			; 3
	jmp	.7		; 3
.5:
	bvc	.4		; 2/3
	lda	<IRQ_BANK	; 3
.6:
	stx	$8000		; 4
	sta	$8001		; 4
.7:
	; set ppu addr
	lda	<IRQ_X		; 3
	and	#$10		; 2
	lsr	a		; 2
	sta	$2006		; 4
	lda	<IRQ_Y		; 3
	sta	$2005		; 4
	ldx	<SCROLL_X	; 3
	asl	a		; 2
	asl	a		; 2
	and	#$e0		; 2
	stx	$2005		; 4
	sta	$2006		; 4

	bvc	.8
	lda	<BANK_SEL
	sta	$8000
.8:

	ldy	<IRQ_CNT
	lda	[IRQ_TBL],y
	sta	<IRQ_X
	iny
	lda	[IRQ_TBL],y
	sta	<IRQ_Y
	iny
	sty	<IRQ_CNT

	dec	<PCM_CNT
	ldy	<PCM_CNT
	lda	[PCM_BASE],y
	sta	$4011
	rts

	; 1st byte 2nd byte
	; BB-NLLLL YYYYYYYY
	;
	; B .. CHR-ROM oN؂ւ
	;      00 : ؂ւȂ
	;      01 : IRQ_BANK  ɐ؂ւ
	;      10 : w֎~
	;      11 : IRQ_BANK+1ɐ؂ւ
	; N .. l[e[uԍ(XN[Yʒu256..511̎ON)
	; L .. ̊荞݃C-1
	; Y .. XN[Yʒu(8bit)
	; L0ł΁Ãt[IRQ荞݂I

.align:
;	.org	(HIGH(.align-1)+1)*256+64
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData0a:
	.db	$17,232, $17,232
	.db	$07,  0, $07, 16, $07, 32, $07, 48
	.db	$07, 64, $07, 80, $07, 96, $07,112
	.db	$07,128, $07,144, $07,160, $07,176
	.db	$07,192, $07,208, $17,  0, $17, 16
	.db	$17, 32, $17, 48, $17, 64, $17, 80
	.db	$17, 96, $17,112, $17,128, $17,144
	.db	$17,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData0b:
	.db	$17,232, $17,232
	.db	$07,  8, $07, 24, $07, 40, $07, 56
	.db	$07, 72, $07, 88, $07,104, $07,120
	.db	$07,136, $07,152, $07,168, $07,184
	.db	$07,200, $07,216, $17,  8, $17, 24
	.db	$17, 40, $17, 56, $17, 72, $17, 88
	.db	$17,104, $17,120, $17,136, $17,152
	.db	$17,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData1a:
	.db	$17,232, $17,232
	.db	$01,  0, $01,230
	.db	$03,  4, $07, 16, $07, 32, $07, 48
	.db	$07, 64, $07, 80, $07, 96, $07,112
	.db	$07,128, $07,144, $07,160, $07,176
	.db	$07,192, $07,208, $17,  0, $17, 16
	.db	$17, 32, $17, 48, $17, 64, $17, 80
	.db	$17, 96, $17,112, $17,128, $17,144
	.db	$01,232, $15,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData1b:
	.db	$17,232, $17,232
	.db	$01,  8, $01,230
	.db	$03, 12, $07, 24, $07, 40, $07, 56
	.db	$07, 72, $07, 88, $07,104, $07,120
	.db	$07,136, $07,152, $07,168, $07,184
	.db	$07,200, $07,216, $17,  8, $17, 24
	.db	$17, 40, $17, 56, $17, 72, $17, 88
	.db	$17,104, $17,120, $17,136, $17,152
	.db	$01,232, $15,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData2a:
	.db	$17,232, $17,232
	.db	$07,  0, $07, 16, $07, 32, $07, 48
	.db	$03, 64
	.db	$d3,228, $1c,163, $1f,176, $12,160
	.db	$13,224, $14,224, $1f,192, $1f,208
	.db	$0f,224, $12,224
	.db	$53, 36, $17, 48, $17, 64, $17, 80
	.db	$17, 96, $17,112, $17,128, $17,144
	.db	$17,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData2b:
	.db	$17,232, $17,232
	.db	$07,  8, $07, 24, $07, 40, $07, 56
	.db	$03, 72
	.db	$d3,228, $1c,163, $1f,176, $12,160
	.db	$13,224, $14,224, $1f,192, $1f,208
	.db	$0f,224, $12,224
	.db	$53, 44, $17, 56, $17, 72, $17, 88
	.db	$17,104, $17,120, $17,136, $17,152
	.db	$17,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData3a:
	.db	$17,232, $17,232
	.db	$01,  0, $dd,162
	.db	                  $47, 32, $07, 48
	.db	$07, 64, $07, 80, $07, 96, $07,112
	.db	$07,128, $07,144, $07,160, $07,176
	.db	$07,192, $07,208, $17,  0, $17, 16
	.db	$17, 32, $17, 48, $17, 64, $17, 80
	.db	$17, 96, $17,112, $17,128, $17,144
	.db	$01,232, $15,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData3b:
	.db	$17,232, $17,232
	.db	$01,  8, $dd,162
	.db	                  $47, 40, $07, 56
	.db	$07, 72, $07, 88, $07,104, $07,120
	.db	$07,136, $07,152, $07,168, $07,184
	.db	$07,200, $07,216, $17,  8, $17, 24
	.db	$17, 40, $17, 56, $17, 72, $17, 88
	.db	$17,104, $17,120, $17,136, $17,152
	.db	$01,232, $15,232, $17,232, $10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData4a:
	.db	$07,  0, $07, 16, $07, 32, $07, 48
	.db	$07, 64, $07, 80, $07, 96, $07,112
	.db	$07,128, $07,144, $07,160, $07,176
	.db	$07,192, $07,208, $17,  0, $17, 16
	.db	$17, 32, $17, 48, $17, 64, $17, 80
	.db	$17, 96, $17,112, $17,128, $17,144
	.db	$17,160, $17,176, $17,192, $17,208
	.db	$10,224
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_SeqData4b:
	.db	$07,  8, $07, 24, $07, 40, $07, 56
	.db	$07, 72, $07, 88, $07,104, $07,120
	.db	$07,136, $07,152, $07,168, $07,184
	.db	$07,200, $07,216, $17,  8, $17, 24
	.db	$17, 40, $17, 56, $17, 72, $17, 88
	.db	$17,104, $17,120, $17,136, $17,152
	.db	$17,168, $17,184, $17,200, $17,216
	.db	$10,232
.align:
	.org	(HIGH(.align+63))*256+(LOW(.align+63)&-64)

Irq_ModeTableL:
	.db	LOW(Irq_SeqData0a), LOW(Irq_SeqData0b)
	.db	LOW(Irq_SeqData1a), LOW(Irq_SeqData1b)
	.db	LOW(Irq_SeqData2a), LOW(Irq_SeqData2b)
	.db	LOW(Irq_SeqData3a), LOW(Irq_SeqData3b)
	.db	LOW(Irq_SeqData4a), LOW(Irq_SeqData4b)

Irq_ModeTableH:
	.db	HIGH(Irq_SeqData0a), HIGH(Irq_SeqData0b)
	.db	HIGH(Irq_SeqData1a), HIGH(Irq_SeqData1b)
	.db	HIGH(Irq_SeqData2a), HIGH(Irq_SeqData2b)
	.db	HIGH(Irq_SeqData3a), HIGH(Irq_SeqData3b)
	.db	HIGH(Irq_SeqData4a), HIGH(Irq_SeqData4b)

ExtendTable_L:
	.db	LOW( 25), LOW( 60), LOW(100), LOW(150)
	.db	LOW(225), LOW(300), LOW(400), LOW(500)
ExtendTable_H:
	.db	HIGH( 25), HIGH( 60), HIGH(100), HIGH(150)
	.db	HIGH(225), HIGH(300), HIGH(400), HIGH(500)

Sound_PcmDrum1:
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20

	.db	$1f,$1e,$1d,$1c,$1b,$1a,$19,$18
	.db	$18,$19,$1a,$1b,$1c,$1d,$1e,$1f
	.db	$20,$21,$22,$23,$24,$25,$26,$27
	.db	$28,$28,$27,$26,$25,$24,$23,$22

	.db	$21,$20,$1e,$1c,$1a,$18,$16,$14
	.db	$14,$14,$14,$16,$18,$1a,$1c,$1e
	.db	$20,$22,$24,$26,$28,$2a,$2c,$2c
	.db	$2c,$2c,$2a,$28,$26,$24,$22,$20

	.db	$1c,$18,$14,$10,$0c,$08,$08,$0c
	.db	$10,$14,$18,$1c,$20,$24,$28,$2c
	.db	$30,$34,$38,$38,$34,$30,$2c,$28
	.db	$24,$20,$1b,$16,$11,$0c,$08,$08

	.db	$0c,$11,$16,$1b,$20,$25,$2a,$2f
	.db	$34,$38,$38,$34,$2f,$2a,$25,$20
	.db	$1a,$14,$0e,$08,$08,$0e,$14,$1a
	.db	$20,$26,$2c,$32,$38,$38,$32,$2c

	.db	$26,$20,$1a,$14,$0e,$08,$0e,$14
	.db	$1a,$20,$26,$2c,$32,$38,$32,$2c
	.db	$26,$20,$18,$10,$08,$08,$10,$18
	.db	$20,$28,$30,$38,$38,$30,$28,$20

Sound_PcmDrum2:
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20

	.db	$1f,$1e,$1d,$1c,$1d,$1e,$1f,$20
	.db	$20,$21,$22,$23,$24,$23,$22,$21
	.db	$20,$1f,$1e,$1d,$1c,$1d,$1e,$1f
	.db	$20,$20,$21,$22,$23,$24,$23,$22

	.db	$21,$20,$1f,$1d,$1c,$1a,$1b,$1d
	.db	$1f,$21,$23,$25,$26,$24,$23,$21
	.db	$20,$1f,$1d,$1c,$1a,$1b,$1d,$1f
	.db	$21,$23,$25,$26,$24,$23,$21,$20

	.db	$1d,$1a,$17,$19,$1c,$1f,$21,$24
	.db	$27,$29,$26,$23,$20,$1d,$1a,$17
	.db	$19,$1c,$1f,$21,$24,$27,$29,$26
	.db	$23,$20,$1c,$18,$14,$19,$1e,$22

	.db	$27,$2c,$28,$24,$20,$1c,$18,$14
	.db	$19,$1e,$22,$27,$2c,$28,$24,$20
	.db	$1a,$14,$19,$1e,$22,$27,$2c,$26
	.db	$20,$1a,$14,$19,$1e,$22,$27,$2c

	.db	$26,$20,$1a,$14,$1a,$20,$26,$2c
	.db	$26,$20,$1a,$14,$1a,$20,$26,$2c
	.db	$26,$20,$1a,$14,$1c,$24,$2c,$26
	.db	$20,$1a,$14,$1c,$24,$2c,$26,$20

Sound_PcmDrum3:
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20
	.db	$20,$20,$20,$20,$20,$20,$20,$20

	.db	$1f,$1d,$1c,$1a,$1c,$1d,$1f,$20
	.db	$20,$21,$23,$24,$26,$24,$23,$21
	.db	$20,$1f,$1d,$1c,$1a,$1c,$1d,$1f
	.db	$20,$20,$21,$23,$24,$26,$24,$23

	.db	$21,$20,$1f,$1c,$1a,$17,$19,$1c
	.db	$1f,$21,$24,$27,$29,$26,$24,$21
	.db	$20,$1f,$1c,$1a,$17,$19,$1c,$1f
	.db	$21,$24,$27,$29,$26,$24,$21,$20

	.db	$1c,$17,$13,$16,$1a,$1f,$21,$26
	.db	$2a,$2d,$29,$24,$20,$1c,$17,$13
	.db	$16,$1a,$1f,$21,$26,$2a,$2d,$29
	.db	$24,$20,$1a,$14,$0e,$16,$1d,$23

	.db	$2a,$32,$2c,$26,$20,$1a,$14,$0e
	.db	$16,$1d,$23,$2a,$32,$2c,$26,$20
	.db	$17,$0e,$16,$1d,$23,$2a,$32,$29
	.db	$20,$17,$0e,$16,$1d,$23,$2a,$32

	.db	$29,$20,$17,$0e,$17,$20,$29,$32
	.db	$29,$20,$17,$0e,$17,$20,$29,$32
	.db	$29,$20,$17,$0e,$1a,$26,$32,$29
	.db	$20,$17,$0e,$1a,$26,$32,$29,$20

